#include <fstream>
#include <vector>
#include <string>
using namespace std;
int nsd(int a, int b)
{
	while (a!=0 && b!=0)
		if (a>b)
			a%=b;
		else
			b%=a;
	return (a+b);
}
int main()
{
	ifstream in ("mutation.dat");
	ofstream out ("mutation.sol");
	int a, b, n, m;
	in >> a >> b >> n >> m;
	string as, bs;
	vector <int> nmut(m);
	in >> as;
	in >> bs;
	for (int i=0; i<m; i++)
		in >> nmut[i];
	int nsdab=nsd(a,b);
	int nskab=a*b/nsdab;
	vector <int> b0(nsdab,0);
	vector <int> b1(nsdab,0);
	for (int i=0; i<b; i++)
		if (bs[i]=='1')
			b1[i%nsdab]++;
		else
			b0[i%nsdab]++;
	int dif=0;
	for (int i=0; i<a; i++)
		if (as[i]=='0')
			dif+=b1[i%nsdab];
		else
			dif+=b0[i%nsdab];
	dif*=n/nskab;
	int difmin=dif;
	int difmax=dif;
	int mutdone=0;
	for (int i=0; difmin>0; i++)
	{
		mutdone++;
		int newdifmin,newdifmax;
		if (difmin>=nmut[i])
			newdifmin=difmin-nmut[i];
		else
			if (difmax<nmut[i])
				newdifmin=nmut[i]-difmax;
			else
				newdifmin=(difmax-nmut[i])%2;
		if (difmax+nmut[i]<=n)
			newdifmax=difmax+nmut[i];
		else
			if (difmin+nmut[i]>n)
				newdifmax=2*n-difmin-nmut[i];
			else
				newdifmax=n-(difmax+nmut[i]-n)%2;
		difmin=newdifmin;
		difmax=newdifmax;
	}
	out << mutdone << endl;
	return 0;
}

