#include <fstream>
#include <map>

using namespace std;
ifstream fin("Mutation.dat");
ofstream fout("Mutation.sol");
const int MNAX = 40000;
const int MMAX = 95000000;

int Amin(int x,int y){
	if (x<y) return x;
	return y;
}
int NOK(int x,int y){
	if (x*y==0) return 0;
	int ans=1;
	int i = Amin(x,y);
	while (i>1){
		while (x%i==0 && y%i==0){
			x/=i;y/=i;
			ans*=i;
		}
		--i;
	}
	ans*=x*y;
	return ans;
}

typedef map <long long,int> TypeTree;
TypeTree dst;
TypeTree dst2;

int sa[MNAX+2],sb[MNAX+2];
int now[MMAX+2],now2[MMAX+2];
int main(){
	int ans = 0;
	int a,b,n,m,i,j;
	fin>>a>>b>>n>>m;
	char ch;
	for (i=1;i<=a;++i){
		fin>>ch;
		sa[i] = ch-'0';
	}
	for (i=1;i<=b;++i){
		fin>>ch;
		sb[i] = ch-'0';
	}
	int nk = NOK(a,b);
	int uans = n/nk;
	n = nk;
	for (i=1;i<=n;++i){
		if (sa[(i-1)%a+1]!=sb[(i-1)%b+1]){++ans;}
	}
	ans *= uans;

	dst.clear();
	dst[0]=1;
	now[1]=0;now[0]=1;
	now2[0]=0;
	int ik=0;

	if (ans==0){j=0;}
	else{
		for (j=1;j<=m;++j){
			int x;
			fin>>x;
			for (i=1;i<=now[0];++i){
				int kk = now[i]-x;
				if (kk<0) kk=-kk;
				TypeTree::const_iterator ii = dst.find(kk);
				if (ii==dst.end()){
					dst[kk]=1;
					now2[now2[0]+1] = kk;
					++now2[0];
				}
		
				kk = now[i]+x;
				ii = dst.find(kk);
				if (ii==dst.end()){
					dst[kk]=1;
					now2[now2[0]+1] = kk;
					++now2[0];
				}
			}
			TypeTree::const_iterator ii = dst.find(ans);
			if (ii!=dst.end()) break;	

			for (i=0;i<=now2[0];++i) now[i]=now2[i];
			now2[0]=0;
		}
	}
	
	fout<<j<<'\n';
	return 0;
}