#include <cstdio>
#include <vector>

#define MAX_N 20

using namespace std;

vector<int> adj[MAX_N];
int n(0),m,MOD;
int RES(0);

void count(vector<bool> used,vector<int> state,int v=0) {
  if (v==n) {
    RES++; 
//	for (int i=0;i<state.size();i++) printf("%d ",state[i]); printf("\n"); 
	return;
  }

  if (!used[v]) {
    state[v]=v;
	used[v]=true;
    count(used,state,v+1);
	used[v]=false;
  }

  for (int i=0;i<adj[v].size();i++)  if (!used[adj[v][i]])
  {
    state[v]=adj[v][i];
	used[adj[v][i]]=true;
	count(used,state,v+1);
	used[adj[v][i]]=false;
  }
}


int main()
{
  freopen("museum.dat","r",stdin);
  freopen("museum.sol","w",stdout);

  scanf("%d%d",&m,&MOD);

  int u,v;

  for (int i=0;i<m;i++) {
    scanf("%d%d",&u,&v);

	if (u>n) n=u; if (v>n) n=v;

	adj[u-1].push_back(v-1);
	adj[v-1].push_back(u-1);
  }

  vector<int> start(n,-1);
  vector<bool> used(n,false);

  count(used,start);

  printf("%d\n",RES);



  return 0;
}