#include <cstdio>
#include <stdlib.h>
#include <algorithm>

using namespace std;

FILE *fi = fopen("MUTATION.DAT", "rt"),
	*fo = fopen("MUTATION.SOL", "wt");

char inp[40000], out[40000];

int cr[40000], crlen;

int t[40000];

int gcd(int a, int b) { return a ? gcd(b % a, a) : b; }

void init(char *a, int al)
{
	crlen = 0;
	for (int i = 0; i < (al - 1); i++)
		if (a[i] != a[i + 1])
			cr[crlen++] = i;
}

int main(int argc, char *argv[])
{
	int a, b, n, m;
	fscanf(fi, "%d %d %d %d", &a, &b, &n, &m);
	fscanf(fi, "%s", inp);
	fscanf(fi, "%s", out);
	int g = a * b / gcd(a, b);

	int k = 0;
	t[0] = 0;
	if (a < b)
	{
		init(inp, a);
		for (int i = 0; i < a; i++)
			if (inp[i] != out[i])
				t[0]++;
		for (int i = 1; i < b; i++)
		{
			t[i] = t[i - 1];
			if (inp[0] != out[i - 1])
				t[i]--;
			for (int j = 0; j < crlen; j++)
			{
				if (inp[cr[j]] != out[(i + cr[j]) % b])
					t[i]++;
				else
					t[i]--;
			}
			if (inp[a - 1] != out[(i + a - 1) % b])
				t[i]++;
		}
		for (int w = 0; w < g; w += a)
			k += t[w % b];
	}
	else
	{
		init(out, b);
		for (int i = 0; i < b; i++)
			if (inp[i] != out[i])
				t[0]++;
		for (int i = 1; i < a; i++)
		{
			t[i] = t[i - 1];
			if (out[0] != inp[i - 1])
				t[i]--;
			for (int j = 0; j < crlen; j++)
			{
				if (out[cr[j]] != inp[(i + cr[j]) % a])
					t[i]++;
				else
					t[i]--;
			}
			if (out[b - 1] != inp[(i + b - 1) % a])
				t[i]++;
		}
		for (int w = 0; w < g; w += b)
			k += t[w % a];
	}
	
	k *= n / g;
	int answ = 0;
	while (k && (answ < m))
	{
		int d;
		fscanf(fi, "%d", &d);
		k = abs(k - d);
		answ++;
	}
	fprintf(fo, "%d\n", answ);

	fclose(fi);
	fclose(fo);
	return 0;
}