#ifndef _DEBUG
	#define __OPTIMIE__ 3
#endif
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
using namespace std;

int Routes(int n,char **M,vector<char> &hash,int i){
	if (i==n){
		for (i=0; i<n; i++) if (!hash[i]) return 0;
		return 1;
	}
	int r=0;
	for (int j=0; j<n; j++){
		if (M[i][j] && !hash[j]) {
			hash[j]=1;
			r+=Routes(n,M,hash,i+1);			
			hash[j]=0;
		}
	}
	return r;
}


int main(){
#ifdef _DEBUG
	freopen("input.txt","r",stdin);
#else
	freopen("museum.dat","r",stdin);
	freopen("museum.sol","w",stdout);
#endif
	int n,p; cin>>n>>p;
	char **M=new char*[n];
	for (int i=0; i<n; i++){
		M[i]=new char[n]; memset(M[i],0,n*sizeof(char));
		M[i][i]=1;
	}
	for (int i=0; i<n; i++){	
		int a,b; cin>>a>>b; --a;--b;
		M[a][b]=1; M[b][a]=1;		
	}
	vector<char> hash(n);	
	int r=Routes(n,M,hash,0);
	cout<<r%p<<'\n';	
	return 0;
}