#include <fstream>
#include <vector>
#include <math.h>
#include <sstream>
#include <string>
using namespace std;
vector<long> a;
vector<long> b;

void Init(int sum)
{
	stringstream st; st<<sum;
	string s; st>>s; st.clear();
	a.resize(s.length()); b.resize(s.length());
	for (int i=0; i<s.length(); i++)
		a[i]=s[i]-0x30;
	return;
}
void Correct(vector<long> &b)
{
	vector<long> c;
	long fst=b[b.size()-1];
	b.pop_back();
	while (fst!=0)
	{
		b.push_back(fst%10);
		fst/=10;
	}
	c=b;
	b.clear();
	for (int i=c.size()-1; i>=0; i--)
		b.push_back(c[i]);
	return;
}

void Mul(int m)
{
	long ost=0;
	b.clear();
	for (int i=a.size()-1; i>=0; i--)
	{
		b.push_back((a[i]*m+ost)%10);
		ost=(a[i]*m+ost)/10;
	}
	b.push_back(ost);
	Correct(b);
	a=b;
}

int FindFirst(int num,int &idx)
{
	int first=0;
	int i=idx;
	while (first/num==0 && i<b.size())
	{
		first*=10;
		first+=b[i];
		i++;
	}
	idx=i;
	return first;
}

int FindNext(int now, int &idx)
{
	int next=now*10; if (idx<b.size()) next+=b[idx];
	idx++;
	return next;
}

void Division(int d,long &mod)
{
	int i=0;
	int ost=0;
	vector<int> ans;
	int now=FindFirst(d,i);
	if (i==b.size() && now/d!=0) ost=now-(d*(now/d)); else
		ost=now;
	while (i<=b.size())
	{
		ans.push_back(now/d);
		ost=now-(d*(now/d));
		now=FindNext(ost,i);
	}

	mod=ost;
}

int main(int argc,char* argv[])
{
	ifstream in("Polynom.dat");
	ofstream out("Polynom.sol");
	int n;
	in>>n;
	long long int sum=0;
	for (int i=0; i<=n*n; i++)
		sum+=i;
	long mnog=sum;
	Init(sum);
	for (int i=0; i<n-1; i++)
		Mul(mnog);		
	long mod;
	Division(9973,mod);
	out<<mod<<endl;
	return 0;
}