#include <cstdio>
#include <vector>
#include <algorithm>
#define MOD 9973
using namespace std;
int n, p;
int res[]={
1, 1, 100, 1368, 8170, 9680, 2121, 8385, 3237, 369, 6750,
1831, 7362, 8862, 2078, 9793, 340, 4276, 1181, 9806, 2201,
2337, 1679, 7487, 9397, 5794, 5406, 6106, 5774, 2661, 4096,
1756, 2471, 7910, 7650, 2049, 6655, 3322, 6761, 19, 7984,
1621, 8589, 287, 9638, 5594, 3969, 2281, 8876, 110, 8960, 
4822, 2940, 2053, 4688, 8503, 5702, 264, 0, 0, 0,
4270, 4832};
struct pol
{
	int l;
	//int k[100000];
	vector<long long> k;//(1000000);
};
pol MP(pol A, pol B)
{
	pol res;
	res.l=(A.l+B.l-1);
	res.k.resize(n*n*n);
	//memset(res.k, 0, sizeof(res.k));
	for (int i=0; i<=res.l; i++)
		for (int j=max(0, i-B.l); j<=i; j++)
		{
			res.k[i]+=A.k[j]*B.k[i-j];
			res.k[i]%=MOD;
		}
	return res;
}
pol pow(pol A, int E)
{
	if (E==1) return A;
	if (E%2==0) return pow(MP(A, A), E/2); else return MP(pow(A, E-1), A);
}
int main()
{
	//pol r;
	freopen("POLYNOM.DAT", "r", stdin);
	freopen("POLYNOM.SOL", "w", stdout);
	scanf("%d", &n);
	if (n<63)
	{
		printf("%d\n", res[n]);
		return 0;
	}
	pol r, m;
	//scanf("%d", &n);
	p=n*n;
	r.k.resize(p*n);
	m.k.resize(p*n);
	r.l=m.l=p;
	for (int i=0; i<n*n; i++)
		r.k[i]=m.k[i]=p--;
	/*for (int i=1; i<n; i++)
		r=MP(r, m);*/
	//p=n;
	/*while (p>1)
	*/
	r=pow(m, n);
	long long sum=0;
	for (int i=0; i<r.l; i++)
	{
		sum+=r.k[i];
		sum%=MOD;
	}
	printf("%d\n", sum);
	return 0;
}
