#include <cstdio>

#define MAX_STR_LEN 40000
#define abs(a) (((a)>=0)?(a):(-(a)))

using namespace std;

char str[2][MAX_STR_LEN];
int strLen[2];
int n,m;

inline int gcd(int a,int b) {
  while (a && b)
    if (a>b) a%=b;
	else b%=a;
  return a+b;
}

inline int diff(const int &len) {
  int lcm=strLen[0]*strLen[1]/gcd(strLen[0],strLen[1]);
  if (len>lcm) return (len/lcm)*diff(lcm);

  int Meets=len/strLen[0];
  int res=0;

  for (int i=0;i<strLen[0];i++) 
    for (int meet=0;meet<Meets;meet++)
	  if (str[0][i]!=str[1][(strLen[0]*meet+i)%strLen[1]]) res++;

  return res;
}

int main()
{
  freopen("mutation.dat","r",stdin);
  freopen("mutation.sol","w",stdout);

  scanf("%d%d%d%d\n",&strLen[0],&strLen[1],&n,&m);

  gets(str[0]); gets(str[1]);

  int need=diff(n);
  int cur,rem=0,l=0,r=0;

  for (int i=0;i<m;i++) {
    scanf("%d",&cur);
	l=abs(l-cur); r=(r+cur<=n)?(r+cur):(2*n-r-cur);
	rem=(rem+cur)%2;

	if (need%2==rem && need>=l && need<=r) {
	  printf("%d\n",i+1); return 0;
	}
  }
  printf("%d\n",m);
  return 0;
}