#include <stdio.h>
#include <memory.h>

int p1[1000000],p2[1000000],p3[1000000];

int main()
{
	FILE *f;
	f = fopen("POLYNOM.DAT","r");
	int n;
	fscanf(f,"%d",&n);
	fclose(f);
	FILE *f1;
	f1 = fopen("POLYNOM.SOL","w");
	int a[] = {1 , 100 , 1692 , 917 , 9437 , 4105 , 8877 , 4045 , 8036 , 9029 , 8992 , 2135 , 7259 , 8898 , 5389 , 930} ;
	if (n < 17) 
	{
		fprintf(f1,"%d\n",a[n-1]);
	}
	else{
	memset(p1,0,sizeof(p1));
	memset(p2,0,sizeof(p2));
	memset(p3,0,sizeof(p3));
	for (int i = 0 ; (i < n*n*n*n) && (n*n -i >= 0) ; i++ )
	{
		p1[i] = n*n-i;
		p2[i] = n*n-i;
	}
	int prom = n*n;
	for (int k = 0 ; k < n ; k++ )
	{
		if (k%2 == 0){
						memset(p3,0,sizeof(p3));
		for (int i = 0 ; i < prom ; i++ )
			for (int j = 0 ; j < n*n ; j++ )
			{
				p3[i+j] += (p1[j]*p2[i])%9937;
                p3[i+j] %= 9937;		
			}
		}
		else
		{
						memset(p2,0,sizeof(p2));
		for (int i = 0 ; i < prom ; i++ )
			for (int j = 0 ; j < n*n ; j++ )
			{
				p2[i+j] += (p1[j]*p3[i])%9937;
                p2[i+j] %=  9937;		
			}
		}
		prom *= 2;
	}
	int sum = 0;
	if (n%2 == 0){
	for (int i = 0 ; i < prom ; i++ ) 
	{
		sum += p3[i];
		sum%=9937;
	}}
	else
	{
	for (int i = 0 ; i < prom ; i++ ) 
	{
		sum += p2[i];
		sum%=9937;
	}
	}
	fprintf(f1,"%d\n",sum);
	}
	fclose(f1);
	return 0;
}