#include<fstream>
#include<vector>
using namespace std;
ifstream fin("polynom.dat");
ofstream fout("polynom.sol");
struct memb
{
    int p;
    int coef;
};
vector<memb> mult(vector<memb> &a,vector<memb> &b)
{
    vector<memb> c;
    memb tmp;
    int i,j;
    for(i=0;i<a.size();i++)
    {
        for(j=0;j<b.size();j++)
        {
            tmp.coef=a[i].coef*b[j].coef;
            tmp.p=a[i].p+b[j].p;
            c.push_back(tmp);
        }
    }
    for(i=0;i<c.size();i++)
    {
        for(j=i+1;j<c.size();j++)
        {
            if(c[j].p==c[i].p)
            {
                c[i].coef+=c[j].coef;
                c.erase(c.begin()+j);
                j--;
            }
        }
    }
    return c;
}
vector<memb> solve(vector<memb> &a, int pow)
{
    vector<memb> b=a;
    while(pow-1)
    {
        b=mult(b,a);
        pow--;
    }
    return b;
};
int main()
{
    unsigned long long int N,i,res=0;
    fin>>N;
    vector<memb> a(N*N),b;
    for(i=1;i<=N*N;i++)
    {
        a[i-1].coef=i;
        a[i-1].p=N*N-i;
    }
    b=solve(a,N);
    for(i=0;i<b.size();i++)
    {
        res+=b[i].coef;
        if(res>=9973)res%=9973;
    }
    fout<<res<<"\n";
}
