#include <fstream>
#include <vector>
#include <set>
using namespace std;

int cnt=0;
vector<set<int> > g;
vector<bool> used;

void dfs(int a) {
  if(used[a])  {
    cnt++;
	return;
  }
  used[a]=true;
  int c=0;
  for(set<int>::iterator i=g[a].begin(); i!=g[a].end(); i++) {
	g[*i].erase(g[*i].find(a));
	dfs(*i);
	c++;
  }
  if(!c) cnt++;
  return;
}

int gcd(int a, int b) {
  while(a!=0 && b!=0) {
    if(a>b) a%=b;
	if(b>=a) b%=a;
  }
  return a+b;
}

int main() {
  ifstream cin("museum.dat");
  ofstream cout("museum.sol");
  int n,p,a,b;
  cin >> n >> p;
  g.resize(n+1);
  used.resize(n+1,false);

  for(int i=0; i<n; i++) {
    cin >> a >> b;
	g[a].insert(b);
	g[b].insert(a);
  }
  dfs(1);
  vector<int> m,k;
  cnt = min(cnt,n-cnt);
  for(int i=n-cnt+1;i<=n;i++)
    m.push_back(i);
  for(int i=2; i<=cnt; i++)
    k.push_back(i);

  int r;
  for(int i=0; i<cnt-1; i++)
	for(int j=0; j<m.size() && k[i]; j++) {
	  r = gcd(k[i],m[j]);
	  k[i]/=r; m[j]/=r;
	}
  r = 1;
  for(int i=0; i<m.size(); i++)
	r=r*m[i]%p;

  cout << r << endl;  
  cin.close(); cout.close();
  return 0;
}